unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    StatusBar1: TStatusBar;
    StatusBar2: TStatusBar;
    Panel1: TPanel;
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ColorDialog1: TColorDialog;
    Shape1: TShape;
    Label4: TLabel;
    ComboBox1: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ComboBox1Change(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseLeave(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    { Private declarations }
    papel : TCanvas;
    x1,y1,x2,y2  : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  papel  :=  Image1.Canvas;
  x1 :=  50; y1 :=  50;
  x2 := 250; y2 := 150;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  err : integer;
begin
  x2 := StrToInt(Edit1.Text);

  val(Edit2.Text,y2,err);
  if(err<>0) then begin
    ShowMessage('Error en entrada para Y2 ...');
    exit;
  end;

  papel.Rectangle(x1,y1,x2,y2);
end;

procedure TForm1.Shape1MouseDown(Sender: TObject;
  Button : TMouseButton;
  Shift  : TShiftState;
  X, Y   : Integer);
var
  col : TColor;
begin
  if ColorDialog1.Execute then begin
    col := ColorDialog1.Color;
    Shape1.Brush.Color := col;
    papel.Pen.Color := col;
  end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
  vv,pp : byte;
begin
  pp := ComboBox1.ItemIndex;
  vv := StrToInt(ComboBox1.Items[pp]);
  papel.Pen.Width := vv;
end;

procedure TForm1.Image1MouseMove(Sender: TObject;
  Shift: TShiftState;
  X, Y : Integer);
var
  Pix, r,g,b : integer;
begin
  StatusBar1.Panels[0].Text := IntToStr(X);
  StatusBar1.Panels[1].Text := IntToStr(Y);

  Pix := papel.Pixels[X,Y];

  r := GetRValue(Pix);
  g := GetGValue(Pix);
  b := GetBValue(Pix);

  StatusBar1.Panels[2].Text := IntToStr(r);
  StatusBar1.Panels[3].Text := IntToStr(g);
  StatusBar1.Panels[4].Text := IntToStr(b);

end;

procedure TForm1.Image1MouseLeave(Sender: TObject);
begin
  StatusBar1.Panels[0].Text := 'fuera';
  StatusBar1.Panels[1].Text := 'fuera';
end;

procedure TForm1.Image1MouseDown(Sender: TObject;
  Button: TMouseButton;
  Shift: TShiftState;
  X, Y: Integer);
begin
  if Button = mbRight then begin
    papel.MoveTo(X,Y);
  end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject;
  Button: TMouseButton;
  Shift: TShiftState;
  X, Y: Integer);
begin
  if Button = mbRight then begin
    papel.LineTo(X,Y);
  end;
end;


end.
